Attribute VB_Name = "mdlGradient"
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function OleTranslateColor Lib "OLEPRO32.DLL" _
    (ByVal OLE_COLOR As Long, _
    ByVal HPALETTE As Long, _
    pccolorref As Long) _
    As Long
Private Declare Function FillRect Lib "user32" _
    (ByVal hDC As Long, _
    lpRect As RECT, _
    ByVal hBrush As Long) _
    As Long
Private Declare Function CreateSolidBrush Lib "gdi32" _
    (ByVal crColor As Long) _
    As Long
Private Declare Function DeleteObject Lib "gdi32" _
    (ByVal hObject As Long) As Long

Private RGBStart(1 To 3) As Integer ' 
Private RGBEnd(1 To 3) As Integer ' 
Private RGBColor() As Integer

Public Enum constOrientation
    Horizontal = 0
    Vertical = 1
End Enum

Public Sub DrawGradient(ObjDestGradient As Object, ColorStart As OLE_COLOR, _
    ColorEnd As OLE_COLOR, eOrientation As constOrientation)
Dim lColor As Long
Dim lHeight As Long, lWidth As Long
Dim lYStep  As Long, lXStep  As Long
Dim i As Long
Dim iRGB(1 To 3) As Integer
Dim dR(1 To 3) As Double
Dim rct As RECT
Dim hBr As Long, lhDC As Long
    
    '   
    OleTranslateColor ColorEnd, 0, lColor
    RGBEnd(1) = lColor And &HFF&
    RGBEnd(2) = ((lColor And &HFF00&) \ &H100)
    RGBEnd(3) = ((lColor And &HFF0000) \ &H10000)
    
    OleTranslateColor ColorStart, 0, lColor
    RGBStart(1) = lColor And &HFF&
    RGBStart(2) = ((lColor And &HFF00&) \ &H100)
    RGBStart(3) = ((lColor And &HFF0000) \ &H10000)
    

    ObjDestGradient.Cls '    

    lhDC = ObjDestGradient.hDC
    lHeight = ObjDestGradient.Height \ Screen.TwipsPerPixelY '  
    lWidth = ObjDestGradient.Width \ Screen.TwipsPerPixelX
    rct.Right = lWidth
    rct.Bottom = lHeight
    
    '   RGB    
    iRGB(1) = RGBStart(1)
    iRGB(2) = RGBStart(2)
    iRGB(3) = RGBStart(3)
    dR(1) = RGBEnd(1) - RGBStart(1)
    dR(2) = RGBEnd(2) - RGBStart(2)
    dR(3) = RGBEnd(3) - RGBStart(3)
    
    Select Case eOrientation
    Case 0    '     
        lYStep = lHeight \ 255
        If (lYStep = 0) Then
            lYStep = 1
        End If
        
        '   ( )
        For i = lHeight To 0 Step -lYStep
            rct.Top = rct.Bottom - lYStep
            hBr = CreateSolidBrush(iRGB(3) * &H10000 + iRGB(2) * &H100& + iRGB(1))
            FillRect lhDC, rct, hBr
            DeleteObject hBr
            rct.Bottom = rct.Top
            iRGB(1) = RGBStart(1) + dR(1) * (lHeight - i) / lHeight
            iRGB(2) = RGBStart(2) + dR(2) * (lHeight - i) / lHeight
            iRGB(3) = RGBStart(3) + dR(3) * (lHeight - i) / lHeight
        Next
    Case 1
        lXStep = lWidth \ 255
        If (lXStep = 0) Then
            lXStep = 1
        End If
        
        '  
        For i = lWidth To 0 Step -lXStep
            rct.Left = rct.Right - lXStep
            hBr = CreateSolidBrush(iRGB(3) * &H10000 + iRGB(2) * &H100& + iRGB(1))
            FillRect lhDC, rct, hBr
            DeleteObject hBr
            rct.Right = rct.Left
            iRGB(1) = RGBStart(1) + dR(1) * (lWidth - i) / lWidth
            iRGB(2) = RGBStart(2) + dR(2) * (lWidth - i) / lWidth
            iRGB(3) = RGBStart(3) + dR(3) * (lWidth - i) / lWidth
        Next
    End Select
End Sub

Public Sub DrawMultiGradient(ObjDestGradient As Object, eOrientation As constOrientation, ParamArray ArrColor())
Dim lColor As Long
Dim lHeight As Long, lWidth As Long
Dim lYStep  As Long, lXStep  As Long
Dim i As Long, j As Long
Dim iRGB() As Integer
Dim dR() As Double
Dim rct As RECT
Dim hBr As Long, lhDC As Long
    
Dim NumColor As Integer
        
    NumColor = UBound(ArrColor)
    ReDim RGBColor(1 To 3, NumColor)
    '   
    For i = 0 To NumColor
        OleTranslateColor ArrColor(i), 0, lColor
        RGBColor(1, i) = lColor And &HFF&
        RGBColor(2, i) = ((lColor And &HFF00&) \ &H100)
        RGBColor(3, i) = ((lColor And &HFF0000) \ &H10000)
    Next

    ObjDestGradient.Cls '    

    lhDC = ObjDestGradient.hDC
    lHeight = ObjDestGradient.Height \ Screen.TwipsPerPixelY '  
    lWidth = ObjDestGradient.Width \ Screen.TwipsPerPixelX
    rct.Right = lWidth
    rct.Bottom = lHeight
    
    '   RGB    
    ReDim iRGB(1 To 3, NumColor) As Integer
    ReDim dR(1 To 3, NumColor) As Double
    
    For i = 0 To NumColor - 1
        iRGB(1, i) = RGBColor(1, i)
        iRGB(2, i) = RGBColor(2, i)
        iRGB(3, i) = RGBColor(3, i)
        dR(1, i) = RGBColor(1, i + 1) - RGBColor(1, i)
        dR(2, i) = RGBColor(2, i + 1) - RGBColor(2, i)
        dR(3, i) = RGBColor(3, i + 1) - RGBColor(3, i)
    Next
    
    Select Case eOrientation
    Case 0    '     
        lYStep = CLng(lHeight / 255 / (NumColor - 1))
        If (lYStep = 0) Then
            lYStep = 1
        End If
        Dim tmpHeight As Long
        '   ( )
        For j = 0 To NumColor
            tmpHeight = lHeight \ NumColor
            For i = tmpHeight To 0 Step -lYStep
                rct.Top = rct.Bottom - lYStep
                hBr = CreateSolidBrush(iRGB(3, j) * &H10000 + iRGB(2, j) * &H100& + iRGB(1, j))
                FillRect lhDC, rct, hBr
                DeleteObject hBr
                rct.Bottom = rct.Top
                iRGB(1, j) = RGBColor(1, j) + dR(1, j) * (tmpHeight - i) / tmpHeight
                iRGB(2, j) = RGBColor(2, j) + dR(2, j) * (tmpHeight - i) / tmpHeight
                iRGB(3, j) = RGBColor(3, j) + dR(3, j) * (tmpHeight - i) / tmpHeight
            Next
        Next
    Case 1
        lXStep = CLng(lWidth / 255 / (NumColor - 1))
        If (lXStep = 0) Then
            lXStep = 1
        End If
        Dim tmpWidth As Long
        '   ( )
        For j = 0 To NumColor
            tmpWidth = lWidth \ NumColor
            For i = tmpWidth To 0 Step -lXStep
                rct.Left = rct.Right - lXStep
                hBr = CreateSolidBrush(iRGB(3, j) * &H10000 + iRGB(2, j) * &H100& + iRGB(1, j))
                FillRect lhDC, rct, hBr
                DeleteObject hBr
                rct.Right = rct.Left
                iRGB(1, j) = RGBColor(1, j) + dR(1, j) * (tmpWidth - i) / tmpWidth
                iRGB(2, j) = RGBColor(2, j) + dR(2, j) * (tmpWidth - i) / tmpWidth
                iRGB(3, j) = RGBColor(3, j) + dR(3, j) * (tmpWidth - i) / tmpWidth
            Next
        Next
    End Select
End Sub

